#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <unistd.h>

#include "util.h"

#define  ERR_FORMAT(n)	(-(n))

static int ln;
int bit_load(FILE *fp, uint8_t *buf, int bufsiz) {
	uint8_t  *p, wk;
	int c,x,i;
	int len;
	int total = 0;
	
	p = buf;

	memset(buf, 0, bufsiz);
	
	for (i=0; i<13; i++) fgetc(fp);
	for (;;) {
		ln ++;
		c = fgetc(fp);
		if (c == EOF) break;
		if (c < 'a' || 'e' < c) {
// printf("# ln %d c = %02x\n", ln, c);
			return ERR_FORMAT(1);
		}
		if (fread (&wk, 1, 1, fp) != 1) return ERR_FORMAT(2);
		len = (int)wk << 8;
		if (fread (&wk, 1, 1, fp) != 1) return ERR_FORMAT(3);
		len += wk;
		if (c == 'e') {
			len <<= 16;
			if (fread (&wk, 1, 1, fp) != 1) return ERR_FORMAT(4);
			len += (int)wk << 8;
			if (fread (&wk, 1, 1, fp) != 1) return ERR_FORMAT(5);
			len += wk;
// printf("# ln %d c = %02x len = %d\n", ln, c, len);
			x = fread (p, 1, len, fp);
			if( x != len) {
// printf("total = %d len = %d x = %d \n", total, len, x);
				return ERR_FORMAT(6);
			}
			*p += len;
			total += len; 
		} else {
// printf("# ln %d c = %02x len = %d\n", ln, c, len);
			for (i=0; i< len; i++) {
				x = fgetc(fp);
				if (x == EOF)  return ERR_FORMAT(5);
			}
		}
		if (total > bufsiz)   return ERR_FORMAT(6);
		
	}

	return total;
}

#ifdef STANDALONE_TEST

main(int argc, char *argv[]) {
	FILE *fp;
	int r;
	uint8_t *buf;

	build_rev();
	fp = fopen(argv[1],"rb");
	if (fp == NULL) exit(1);
	buf = malloc(1024 * 1024 * 2);
	r = bit_load(fp, buf, 1024 * 1024 * 2);
	printf("ln %d size %d\n", ln , r);
	dump(buf, 0x0000, (r>0)? r : 256, 0);
}
#endif
