#ifndef jtag_h
#define jtag_h

/* internal state */
#define JTAG_STATE_UNKOWN	0
#define JTAG_STATE_IDLE		1
#define JTAG_STATE_SIR		2
#define JTAG_STATE_EXIT1_IR	3
#define JTAG_STATE_SDR		5
#define JTAG_STATE_EXIT1_DR	6

/* flags of jtag_SIRxx , jtag_SDRxx */
#define JTAG_RECV		1
#define JTAG_CONT		2 /* TMS : no changed */

#ifdef __cplusplus
extern "C" {
#endif

void jtag_go(CABLE cbl,int state);
void jtag_init(CABLE cbl);
void jtag_reset(CABLE cbl);
void jtag_IDLE(CABLE cbl, int ms, int count);
void jtag_SIR(CABLE cbl, uint8_t *buf, int bit_len, int flags, uint8_t *rcv_buf);
void jtag_SDR(CABLE cbl, uint8_t *buf, int bit_len, int flags, uint8_t *rcv_buf);
void jtag_SDR_EX(CABLE cbl, uint8_t *buf, int off, int bit_len, int flags, uint8_t *rcv_buf, int roff);

void jtag_SIR32(CABLE cbl, uint32_t code, int bit_len, int flags, uint32_t *rcv_data);
void jtag_SDR32(CABLE cbl, uint32_t code, int bit_len, int flags, uint32_t *rcv_data);
// MSB first version for SPI
void jtag_SDR32R(CABLE cbl, uint32_t code, int bit_len, int flags, uint32_t *rcv_data);

#ifdef __cplusplus
}
#endif

#endif /* jtag_h */
