#ifndef target_h
#define target_h

#ifdef __cplusplus
extern "C" {
#endif

typedef struct target *TARGET;

#define SPI_CHAN	1
#define ISP_CHAN	2

struct target {
	int  (* sel_chan)(TARGET tgt, CABLE cbl, int chan);
	int  (* read_conf)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* write_conf)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* read_flash)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* write_flash)(TARGET tgt, CABLE cbl, uint8_t *buf, int len);
	int  (* erase_flash)(TARGET tgt, CABLE cbl);

	uint32_t device_id;
	uint32_t user_id;

	/* for lattice FPGA's parameter */
	uint32_t crc_data;   // optinal (XP2)
	uint32_t feature_lo; // optinal (MachXO2)
	uint32_t feature_hi; // optinal (MachXO2)
	uint32_t feabits;    // optinal (MachXO2)
	int address_size;
	int data_width;
	int boundary_width;
	int flash_col;
	int flash_cfm_row;
	int flash_ufm_row;
	char *device_name;
};

#ifdef __cplusplus
}
#endif

#endif /* target_h */
