#ifndef tgtlscc_h
#define tgtlscc_h

// IR instructions
#define LSCC_IPA	0x32
#define LSCC_IPB	0x38
#define LSCC_IDCODE	0x16
#define LSCC_USERCODE	0x17
#define BYPASS_8	0xFF

#define PRELOAD			0x1C
#define ISC_ENABLE		0x15
#define ISC_ERASE		0x03
#define READ_STATUS		0xB2
#define INIT_ADDRESS		0x21
#define LSCC_PROGRAM_INCR_RTI	0x67
#define LSCC_RESET_ADDRESS	0x21
#define LSCC_READ_INCR_RTI	0x6A
#define ISC_PROGRAM_DONE	0x2F
#define ISC_DISABLE		0x1E
#define ISC_PROGRAM_USERCODE	0x1A

/* XP2 only */
#define ISC_PROGRAM_STATUS	0x52
#define ISC_ERASE_DONE		0x24
#define PROGRAM_SED_CRC		0x45
#define READ_SED_CRC		0x44
#define LSCC_READ_CONTROL	0x4A

/* XO only */
#define ISC_SRAM_ENABLE		0x55
#define DATA_SHIFT		0x02

/* XO2 only */
#define XO2_IDCODE		0xE0
#define XO2_USERCODE		0xC0
#define XO2_ISC_ENABLE		0xC6
#define XO2_ISC_ERASE		0x0E
#define XO2_ISC_DISABLE		0x26
#define XO2_READ_STATUS		0x3C
#define XO2_CHECK_BUSY		0xF0

#define XO2_INIT_ADDRESS	0x46
#define XO2_INIT_ADDR_UFM	0x47
#define XO2_VERIFY_INCR_RTI	0x6A // same as LSCC_READ_INCR_RTI
#define XO2_PROGRAM_INCR_RTI	0x82
#define XO2_PROGRAM_USERCODE	0xC2
#define XO2_PROGRAM_DONE	0x5E
#define XO2_READ_INCR_NV	0x73
#define XO2_READ_FEATURE	0xE7
#define XO2_READ_FEABITS	0xFB
#define XO2_WAIT_ADDRESS	0xB4
#define XO2_PROG_INCR_NV	0x70
#define XO2_PROG_FEATURE	0xE4
#define XO2_PROG_FEABITS	0xF8

#define XO2_READ_CTRL0		0x20
#define XO2_PROG_CTRL0		0x22
#ifdef __cplusplus
extern "C" {
#endif

int tgtlscc_init (TARGET tgt, CABLE cbl, char *dev_name);

#ifdef __cplusplus
}
#endif

#endif /* tgtlscc_h */
